#
# $Id: base.py,v 1.2 2006/05/19 23:50:35 mwalfish Exp $
#
#
# Copyright (C) 2005-2006 Michael Walfish
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
# 02110-1301, USA.
#
import os

COMMENT_CHAR = '#'

def parse_config_file(fname, PLURALS, DICTS, REQUIRED):
    """Parses a config file and returns its contents as a dictionary in
    which the entries that are allowed to be plural are lists of strings and 
    in which the other entries are strings. Raises an exception if any of
    the 'required' values isn't present."""
    d = {}
    if os.path.exists(fname) is not True:
	raise ValueError, 'config file %s doesn\'t exist' % fname

    f = file(fname, 'r')
    for line in f.readlines():

	s = line.strip()
	if (len(s) == 0) or (s[0] == COMMENT_CHAR): continue

	splits = s.split()
	attr = splits[0]
	if attr in PLURALS: 
	    val = splits[1]
	    if d.has_key(attr) is False: d[attr] = [val]
	    else: d[attr].append(val)
	elif attr in DICTS:
	    k,v = splits[1],splits[2]
	    if d.has_key(attr) is False: d[attr] = {k : v}
	    else: d[attr][k] = v
	else: 
	    val = splits[1]
	    d[attr] = val

    for r in REQUIRED:
	if d.has_key(r) is False:
	    raise ValueError, 'missing entry of type %s' % r

    return d

