#
# Copyright (C) 2005-2006 Michael Walfish
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
# 02110-1301, USA.
#
import dqm.config.base as base_conf
import dqm.cryptkey_wrap.cryptkey as cryptkey

PLURALS  = ['portal']
DICTS    = ['trusted_signer']
REQUIRED = ['privkey_file', 
	    'certificate_file', 
	    'stamp_pool', 
	    'trusted_signer', 
	    'portal', 
	    'set_queue']

def parse_config(fname):

    d = base_conf.parse_config_file(fname, PLURALS, DICTS, REQUIRED)

    # convert from string representation to internal representation
    # for the allowed public keys of the signer
    signers_dict = d['trusted_signer']
    for k in signers_dict.keys():
	signers_dict[k] = cryptkey.str_to_pubkey(signers_dict[k])

    return d
