#
# $Id: fifoq.py,v 1.2 2006/05/19 23:50:35 mwalfish Exp $
#

# Simple linked list to implement a fifoq. linked list elements
# are two element python lists (python tuples won't work b/c they are 
# immutable).
#
# Copyright (C) 2005-2006 Michael Walfish
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
# 02110-1301, USA.
#
class fifoq:

    def __init__(self):
	self.head = None
	self.tail = None
	self.size = 0

    def __len__(self):
	return self.size

    def __str__(self):
	# not the best way, but I'm under serious time pressure here.
	# XXX
	return str(self.head)

    def front(self):
	ret = self.head
	if ret is None: return None
	else:           return ret[0]

    def pop(self):
	
	ret = self.head
	if self.head is None: 
	    return None
    
	self.head = ret[1]
	if ret is self.tail:
	    self.tail = None

	self.size = self.size - 1
	return ret[0]

    def append(self, item):

	self.size = self.size + 1

	# save global accesses, which makes the code harder to read
	new_node = [item, None]

	if self.head is None:
	    self.head = self.tail = new_node
	    return
	
	ref_head = self.head
	ref_tail = self.tail

	if ref_head is ref_tail: ref_head[1] = new_node
	else:                    ref_tail[1] = new_node
    
	self.tail = new_node


if __name__ == "__main__":

    f = fifoq()
    for i in range(25):
	f.append(i)

    for i in range(25):
	a = f.pop()
	if a != i: print 'a: %d. i: %d' % (a,i); assert(False)

    a = f.pop()
    if a is not None: print 'major problem, dude'; assert(False)
