#! /bin/env python
#
# $Id: test_simple.py,v 1.10 2006/05/19 23:50:35 mwalfish Exp $
#
#   brain-dead functions for testing the equally braindead 'simple' version
#   of the stamp pool

#
# Copyright (C) 2005-2006 Michael Walfish
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
# 02110-1301, USA.
#
import os
import random
import copy
import dqm.stamp_pool.simple as simple_pool
import sys

if __name__ == "__main__":
  
    quota = 50
    fname = "/tmp/qwerty" + str(random.random())
    f = file(fname, 'wb')
    f.write('foo')
    f.close()

    dpool1 = simple_pool.create_new(quota, fname)
    os.remove(fname)
    dpool2 = simple_pool.create_new(quota, fname)
    dpool3 = simple_pool.create_from_file(fname)

    # to shut pychecker up
    copyfunc = copy.deepcopy

    def a_test():
	l = []
	dpool4 = copyfunc(dpool3)
	for i in range(quota):
	    r = dpool4.consume_disposable()
	    if r in l: return False
	    l.append(r)

	# checks
	if dpool4.num_left() != 0: return False 
	if dpool4.get_quota() != quota: return False

	r = dpool4.consume_disposable()
	if r != -1: return False

	return True

    fname2 = "/tmp/dskfa" + str(random.random()) 
    dpool3.write_out(fname2)
    dpool5 = simple_pool.create_from_file(fname2)
    rc = (dpool5 == dpool3)

    tests = [(lambda: dpool1 is not None, "simple check?"),
	     (lambda: dpool2.pool == range(quota), "simple check?"),
	     (lambda: dpool3 == dpool2, "another sanity check?"),
	     (lambda: a_test() is True, "non-duplicates?"),
	     (lambda: rc is True, "read_in and write_out work?")]

    os.remove(fname)
    os.remove(fname2)

    for test,msg in tests:
	print msg,
	if not test(): print "FAILED"; sys.exit(1)
	else: print "passed"
