#! /bin/env python
#
# $Id: sample-rcvr.py,v 1.2 2006/05/19 23:50:35 mwalfish Exp $
#
#  simple command-line app to demonstrate how to test the receiver, a/k/a
#  the stamp verifier
#
#
# Copyright (C) 2005-2006 Michael Walfish
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
# 02110-1301, USA.
#
import sys
import dqm.logger
import dqm.err     as dqm_err
import dqm.config.user  as dqm_config
import dqm.user.rcvr    as dqm_rcvr

if __name__ == "__main__":
    """This is a simple command-line app to verify a stamp that is
    read from stdin."""

    def usage():
	print """usage: %s config-file""" % sys.argv[0]

    def usage_and_exit():
	usage()
	sys.exit(2)

    if len(sys.argv) != 2:
	usage_and_exit()

    config_obj = dqm_config.parse_config(sys.argv[1])

    logger = dqm.logger.stderr_logger()
    Rcvr   = dqm_rcvr.Receiver(config_obj, logger)

    stamp_str = sys.stdin.read()
    stamp_str = stamp_str.strip()
    rc = Rcvr.process_stamp(stamp_str)
    print  dqm_err.str_codes[rc]
