/*
 * Copyright (C) 2005-2006 Michael Walfish
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
 * 02110-1301, USA.
 */
#include <stdio.h>
#include <stdlib.h>
#include "index_map.h"
#include "sha1.h"

int main(int argc, char** argv)
{
    index_map* im;
    ptr<dqm_key> key;

    if (argc != 3) {
	printf("usage: %s index_size num_elements\n", argv[0]);
	return 1;
    }

    // init
    srand(time(NULL));
    im = New index_map(atoi(argv[1]));
    int n = atoi(argv[2]);

    for (int i = 0; i < n; i++) {
	char dummybuf[64];
	sprintf(dummybuf, "%d\n", i);

	key = New refcounted<dqm_key> ();
	sha1_hash(key->base(), dummybuf, strlen(dummybuf));

	im->insert(key, i);
    }

    printf("overflows: %d\n", im->getoverflows());
    printf("empties: %d\n", im->getemptyinserts());
    //im.dump();

    return 0;
}
