/*
 * Copyright (C) 2005-2006 Michael Walfish
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
 * 02110-1301, USA.
 */
#include "sha1.h"
#include "index_map.h"


int main(int argc, char** argv)
{
    ptr<dqm_key> key = New refcounted<dqm_key> ();
    ptr<dqm_key> key2 = New refcounted<dqm_key> ();
    ptr<dqm_key> key3 = New refcounted<dqm_key> ();

    memset(key->base(),  0x0a, key->size());
    memset(key2->base(), 2, key2->size());
    memset(key3->base(), 3, key2->size());

    index_map m(120000);
    int coll = 0;

    index_t i1, i1test, i2;
    i1 = m.lookup(key);
    if (i1 != index_map::EMPTY_ENTRY)
	assert(false);

    i1 = 0x00123456;
    m.insert(key, i1);

    i1test = m.lookup(key);
    if (i1test != i1)
	assert(false);

    for (u_int32_t j = 0; j < 119000; j++) {
	char dummybuf[256];
	sprintf(dummybuf, "%d\n", j);
	ptr<dqm_key> k = New refcounted<dqm_key>();
	sha1_hash(k->base(), dummybuf, strlen(dummybuf));

	if ( (i2 = m.lookup(k)) != index_map::EMPTY_ENTRY) {
	    printf("got a collision. j: %d. idx: %d. coll: %d.\n", 
	           j, i2, coll++);
	    m.insert(k, j);
	    if (m.lookup(k) != j)
		assert(false);
	} else {
	    m.insert(k,j);
	}
    }
   
    while (1) {}

    return 1;
}
