/*
 * Copyright (C) 2005-2006 Michael Walfish
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
 * 02110-1301, USA.
 */
#include <stdio.h>
#include "async.h"
#include "keyvalstore.h"

int
main(int argc, char** argv)
{
    ptr<dqm_key> key = New refcounted<dqm_key> ();
    ptr<dqm_key> key2 = New refcounted<dqm_key> ();
    ptr<dqm_key> key3 = New refcounted<dqm_key> ();

    memset(key->base(), 0,  key->size());
    memset(key2->base(), 0, key2->size());
    memset(key3->base(), 0, key3->size());

    key->base()[0]  = 0x01;
    key2->base()[0] = 0x03;
    key2->base()[1] = 0x01;

    summary summ(8);
    summ.add(key);

    summary_stat stat = summ.test(key2);
    switch (stat) { 
	case DEFINITELY_NOT:
	    printf("DEFINITELY_NOT\n");
	    break;
	
	case MAYBE:
	    printf("MAYBE\n");
	    break;

	default:
	    assert(false);
    }

    return 1;
}
