/*
 * Copyright (C) 2005-2006 Michael Walfish
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
 * 02110-1301, USA.
 */
#include <stdio.h>
#include "heap.h"
#include <stdlib.h>
#include <assert.h>

int main(int argc, char** argv)
{
    Heap<int> myq(1000);

    for (int i = 0; i < 1000000; i++) {
	int r = rand();
	myq.insert(r);
    }

    int last, curr;
    last = myq.extract_min();
    curr = myq.extract_min();
    int i = 0;
    while (curr != 0) {
	if (curr < last) {
	    printf("i: %d. curr: %d. last: %d\n", i, curr, last);
	    assert(0);
	}
	last = curr;
	curr = myq.extract_min();
	++i;
    }
}
