/*
 * Copyright (C) 2005-2006 Michael Walfish
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
 * 02110-1301, USA.
 */
/*
 * $Id: u.h,v 1.5 2006/05/19 13:17:03 mwalfish Exp $
 */ 
#ifndef _UHUHUH_
#define _UHUHUH_

#include <stdio.h>
#include <stdlib.h>

#ifdef DMALLOC
#include <typeinfo>
#include <dmalloc.h>
#endif

#include <sys/time.h>
#include <sys/types.h>
#include <sys/select.h>
#include <sys/socket.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <signal.h>
#include <time.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <unistd.h>
#include <netdb.h>
#include <assert.h>
#include <string.h>
#include "util.h"

typedef unsigned char  uint8;
typedef unsigned short uint16;
typedef unsigned long   uint32;
typedef unsigned long long  uint64;

#define PERROR(x)  { perror(x); exit(1); }
#define WORDY_ERROR(x, y) \
	{ char errbuf[256]; \
	sprintf(errbuf, x, y); \
	PERROR(errbuf) } \


#define MAX_PORTALS 256	    /* I'm an optimist */

#define KEY_VAL_LEN            20

#define ROUGH_METASTAMP_SIZE   800

//#define min(x,y) ( (x < y) ? x : y )

typedef struct _portal {
    char name[80];
    uint16 port;   
    struct sockaddr_in addr;
} portal;

typedef struct _portals {
    int num;
    portal* list[MAX_PORTALS];
} portals;

typedef struct _kv {
    uint8 key[KEY_VAL_LEN];
    uint8 val[KEY_VAL_LEN];
} kv;

typedef struct _kvs {
    int num;
    kv* pairs;
} kvs;

void handle_sigint(int signal);
void dump_stats();

#endif
